<https://dl.acm.org/doi/pdf/10.1145/3485513>

Copy and patch is a novel compilation technique introduced in the above paper that functions (on a broad level) by stitching together code from a large library of binary implementation variants.

They provide two example use cases, a compiler for a C-like language, and a WebAssembly compiler, and show promising results for both startup time and execution performance.



# Terminology
| Phrase             | Definition                                                                                                                                              |
| ------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Stencil            | A binary implementation that has holes where missing values must be inserted during codegen.                                                            |
| Full Compiler      | A compiler that compiles from a high level language to machine code                                                                                     |
| Bytecode Assembler | An assembler that converts low level bytecode to machine code.                                                                                          |
| Baseline compiler  | In tiered compilation, a baseline compiler is the first compiler. It's meant to be the fastest, with the lowest priority on generating performant code. |